/////////////////////////////////////////////////////////

// constants
var ITEMTYPE_FOLDER = 1;
var ITEMTYPE_PLAYLIST = 2;
var ITEMTYPE_FILE = 3;

/////////////////////////////////////////////////////////

function create_item(ownerWindow,sID,sTitle,sText,nItemType,nLevel,sMIMEType,itemclass,div0class,div1class,div2class,spanclass)
{
	// create new item
	var objNewItem = ownerWindow.document.createElement('DIV');

	// set item class
	if ( itemclass!=null ) {
		objNewItem.className = itemclass;
	}

	// set item properties
	objNewItem.id = sID;	
	objNewItem.unselectable = 'on';
	objNewItem.setAttribute('itemtype',nItemType);
	objNewItem.setAttribute('level',nLevel);
	objNewItem.setAttribute('containerExpanded','no');

	if ( nLevel>0 ) {
		objNewItem.style.paddingLeft = (nLevel*17) + 'px';
	}
	
	if ( sTitle!=null ) {
		objNewItem.title = sTitle;		
	}
	
	if ( sMIMEType.length>0 ) {
		objNewItem.setAttribute('mimetype',sMIMEType);
	}
	
	// attach events (browser depending)
	if ( navigator.userAgent.toLowerCase().indexOf('msie')>-1 )
	{
		objNewItem.attachEvent('onclick',ownerWindow.on_item_click);
		objNewItem.attachEvent('ondblclick',ownerWindow.on_item_dblclick);			
	}
	else
	{
		objNewItem.addEventListener('click',ownerWindow.on_item_click,false);
		objNewItem.addEventListener('dblclick',ownerWindow.on_item_dblclick,false);			
	}

	// --- create div 0 (contains addfolder button on some folders) --- //
	var objDiv0 = ownerWindow.document.createElement('DIV');
	objDiv0.unselectable = 'on';
	if ( div0class!=null ) {
		objDiv0.className = div0class;
	}
	
	// --- create div 1 (contains the folder plus/minus) --- //
	var objDiv1 = ownerWindow.document.createElement('DIV');
	objDiv1.unselectable = 'on';
	if ( div1class!=null ) {
		objDiv1.className = div1class;
	}	
	
	// --- create div 2 (contains the item image) --- //
	var objDiv2 = ownerWindow.document.createElement('DIV');
	objDiv2.unselectable = 'on';		
	if ( div2class!=null ) {
		objDiv2.className = div2class;
	}
	
	// --- create span (contains the item text)
	var objSpan = ownerWindow.document.createElement('SPAN');
	objSpan.unselectable = 'on';		
	if ( spanclass!=null ) {
		objSpan.className = spanclass;
	}
	objSpan.innerHTML = sText;

	// append elements to new item
	objNewItem.appendChild(objDiv0);
	objNewItem.appendChild(objDiv1);
	objDiv1.appendChild(objDiv2);
	objDiv2.appendChild(objSpan);

	return objNewItem;
}

/////////////////////////////////////////////////////////

function create_itemcontainer(ownerWindow)
{
	var objContainer = ownerWindow.document.createElement('DIV');
		objContainer.className = 'containerHidden';
		
	return objContainer;
}

/////////////////////////////////////////////////////////

function get_item_from_clicked_element(objElement)
{
	if ( objElement==null ) {
		return null;
	}
	
	if ( objElement.className.length<9 ) {
		return null;
	}
	
	if ( objElement.className.substr(0,5)=='item_' ) {
		return objElement;
	}	
	else if ( objElement.className.substr(0,11)=='itemchild0_' ) {
		return objElement.parentNode;
	}	
	else if ( objElement.className.substr(0,11)=='itemchild1_' ) {
		return objElement.parentNode;
	}
	else if ( objElement.className.substr(0,11)=='itemchild2_' )
	{
		return objElement.parentNode.parentNode;
	}
	else if ( objElement.className.substr(0,11)=='itemchild3_' )
	{
		return objElement.parentNode.parentNode.parentNode;
	}
	else
	{	
		return null;
	}
}

/////////////////////////////////////////////////////////
	
function get_item_container(objItem)
{
	if ( objItem==null ) {
		return null;
	}
	
	var objContainer = null;
	
	var loopCount = 0;
	var loopLimit = 10;
	
	objContainer = objItem.nextSibling;
	while ( objContainer!=null && objContainer.nodeName!='DIV' )
	{
		objContainer = objContainer.nextSibling;
		if ( ++loopCount>loopLimit ) {
			break;
		}
	}
	
	if ( objContainer!=null && objContainer.className!='containerHidden' && objContainer.className!='containerVisible' ) {
		objContainer = null;
	}
	
	return objContainer;
}

/////////////////////////////////////////////////////////
	
function highlight_item(objItem,objCurrentHighlightedItem)
{		
	var objItemText = null;		

	// change classname on old itemtext
	if ( objCurrentHighlightedItem!=null )
	{
		objItemText = get_itemchild3(objCurrentHighlightedItem);		
		if ( objItemText!=null ) {			
			objItemText.className = 'itemchild3_normal';		
		}
	}
	
	if ( objItem==null ) {
		return;
	}		

	// set classname on new itemtext
	objItemText = get_itemchild3(objItem);
	
	if ( objItemText!=null ) {
		objItemText.className = 'itemchild3_active';
	}
}

/////////////////////////////////////////////////////////
	
function toggle_folder_images(objItem)
{
	if ( objItem==null ) {
		return;
	}

	var objItemChild1 = null;
	var objItemChild2 = null;
	
	// get folder expandable image
	objItemChild1 = get_itemchild1(objItem);
	
	// get folder image
	objItemChild2 = get_itemchild2(objItem);

	// if item container is expanded
	if ( objItem.getAttribute('containerExpanded')=='yes' )
	{
		if ( objItemChild1!=null && objItemChild1.className=='itemchild1_plus' ) {
			objItemChild1.className='itemchild1_minus';
		}
		
		if ( objItemChild2!=null ) {
			objItemChild2.className='itemchild2_folder_open';
		}
	}
	else
	{
		if ( objItemChild1.className=='itemchild1_minus' ) {
			objItemChild1.className='itemchild1_plus';
		}

		if ( objItemChild2!=null ) {
			objItemChild2.className='itemchild2_folder_closed';
		}
	}
}

/////////////////////////////////////////////////////////
	
function get_itemchild1(objItem)
{
	if ( objItem==null ) {
		return;
	}
	
	if ( objItem.childNodes )
	{	
		if ( !objItem.childNodes[2] ) {
			return objItem.childNodes[1];
		}
		else {
			return objItem.childNodes[2];
		}
	}
}

/////////////////////////////////////////////////////////
	
function get_itemchild2(objItem)
{
	if ( objItem==null ) {
		return;
	}

	if ( objItem.childNodes )
	{
		if ( !objItem.childNodes[2] ) {
			return objItem.childNodes[1].childNodes[0];
		}
		else {
			return objItem.childNodes1[2].childNodes[1];
		}
	}
}

/////////////////////////////////////////////////////////
	
function get_itemchild3(objItem)
{
	if ( objItem==null ) {
		return;
	}

	if ( objItem.childNodes!=null )
	{
		if ( !objItem.childNodes[2] ) {
			return objItem.childNodes[1].childNodes[0].childNodes[0];
		}
		else {
			return objItem.childNodes1[2].childNodes[1].childNodes[1];
		}
	}
}

/////////////////////////////////////////////////////////

function make_item_editable(objItem)
{
	if ( objItem==null ) {
		return;
	}
	
	var objTextItem = get_itemchild3(objItem);
	if ( objTextItem==null ) {
		return;
	}
	
	// make sure text item is a span element
	if ( objTextItem.tagName!='SPAN' ) {
		return;
	}
	
	// create input element
	var objInput = document.createElement('INPUT');	
	objInput.type='text';
	objInput.value=objTextItem.innerHTML;
	objInput.className='itemchild3_editable';
	
	// replace current text item with our input element
	objTextItem.parentNode.replaceChild(objInput,objTextItem);
}

/////////////////////////////////////////////////////////

function make_item_normal(objItem)
{
	if ( objItem==null ) {
		return;
	}
	
	var objTextItem = get_itemchild3(objItem);
	if ( objTextItem==null ) {
		return;
	}

	// make sure text item is a input element
	if ( objTextItem.tagName!='INPUT' ) {
		return;
	}
	
	// create span element
	var objSpan = document.createElement('SPAN');
	
	objSpan.className = 'itemchild3_active';
	objSpan.unselectable ='on';
	objSpan.innerHTML = objTextItem.value;
	
	// replace current text item with our span element
	objTextItem.parentNode.replaceChild(objSpan,objTextItem);
}

/////////////////////////////////////////////////////////